import{stdout,stderr}from"node:process";
import{promisify}from"node:util";

import chalk from"chalk";

import{printInvalidCommand}from"./fault.js";
import{printVersionHeader}from"./header.js";
import{writeProcessOutput}from"./output.js";



const pSetTimeout=promisify(setTimeout);















export const handleSingleError=({
originalMessage,
code,
exitCode=DEFAULT_EXIT_CODE
})=>{
if(originalMessage!==undefined){
stderr.write(`${originalMessage}\n`);
}

printInvalidCommand(code,exitCode);

return exitCode;
};


export const handleSerialError=(error,versionRange,state)=>{
handleMultipleError(error,versionRange,state);
};




export const handleParallelError=async({
error,
versionRange,
continueOpt,
state,
index
})=>{
if(continueOpt){
handleAnyParallelError({error,versionRange,state,index});
return;
}


await pSetTimeout(0);

handleFastParallelError({error,versionRange,state,index});
};


const handleFastParallelError=({error,versionRange,state,index})=>{
printAborted({error,versionRange,state,index});
handleAnyParallelError({
error:state.failedError,
versionRange:state.failedVersionRange,
state,
index:state.failedIndex
});
};




const printAborted=({
error,
versionRange,
state:{failedError,failedVersionRange},
index
})=>{
if(failedError===error){
return;
}

writeProcessOutput(error.all,stdout,index);

stderr.write(chalk.red(`Node ${versionRange} aborted\n`));

printVersionHeader(failedVersionRange);
};


const handleAnyParallelError=({error,versionRange,state,index})=>{
writeProcessOutput(`${error.all}\n`,stdout,index);
handleMultipleError(error,versionRange,state);
};








const handleMultipleError=(
{shortMessage,code,exitCode=DEFAULT_EXIT_CODE},
versionRange,
state)=>
{
const commandMessage=getCommandMessage(shortMessage,versionRange);
stderr.write(`${commandMessage}\n`);

printInvalidCommand(code,exitCode);

state.exitCode=exitCode;
};

const getCommandMessage=(shortMessage,versionRange)=>
chalk.red(
shortMessage.
replace(COMMAND_REGEXP,"").
replace("Command",`Node ${versionRange}`));



const COMMAND_REGEXP=/:.*/u;

const DEFAULT_EXIT_CODE=1;
//# sourceMappingURL=error.js.map